/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import com.aetrion.flickr.Flickr;
import com.aetrion.flickr.REST;
import com.aetrion.flickr.photos.Photo;
import com.aetrion.flickr.photos.PhotoList;
import com.aetrion.flickr.photos.PhotosInterface;
import com.aetrion.flickr.photos.SearchParameters;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.google.gdata.client.youtube.*;
import com.google.gdata.data.Person;
import com.google.gdata.data.extensions.Rating;
import com.google.gdata.data.geo.impl.GeoRssWhere;
import com.google.gdata.data.media.mediarss.MediaKeywords;
import com.google.gdata.data.media.mediarss.MediaPlayer;
import com.google.gdata.data.media.mediarss.MediaThumbnail;
import com.google.gdata.data.youtube.*;
import com.google.gdata.data.youtube.VideoFeed;
import java.net.URL;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author Keouirak
 */
public class Search extends HttpServlet {

    // The name of the server hosting the YouTube GDATA feeds
    public static final String YOUTUBE_GDATA_SERVER =
            "http://gdata.youtube.com";
    // The URL of the "Videos" feed
    public static final String VIDEOS_FEED =
            YOUTUBE_GDATA_SERVER + "/feeds/api/videos";
    // The URL of the "Standard" feed
    public static final String STANDARD_FEED =
            YOUTUBE_GDATA_SERVER + "/feeds/api/standardfeeds/";

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {

            String searchTerms = request.getParameter("query");
            out.write("<b>results for " + searchTerms + "<br/>");
            YouTubeService service = new YouTubeService("gdataSample-YouTube-2");
            YouTubeQuery query = new YouTubeQuery(new URL(VIDEOS_FEED));


            query.setStartIndex(1);
            query.setMaxResults(20);
            query.setFullTextQuery(searchTerms);

            Flickr flickr = new Flickr("47422029b3aabee4aca6a5853eca74b6", "ab7f2d30639a9828", new REST());
            PhotosInterface pi = flickr.getPhotosInterface();
            SearchParameters sp = new SearchParameters();
            sp.setText(searchTerms);

            PhotoList photoList = pi.search(sp, 50, 1);
            Iterator it = photoList.iterator();

            out.write("<div class=\"photo\"><br/>");
            while (it.hasNext()) {
                Photo photo = (Photo) it.next();
                //out.println("<img src='" + photo.getThumbnailUrl() + "' />");
                out.write("<button id=\"buttonTwo\" dojoType=\"dijit.form.Button\" onclick=\"showDialogPhoto('"+photo.getLargeUrl()+"');\" ><img src=\"" + photo.getThumbnailUrl() + "\" border=\"0\" /></button>");
            }
            out.write("</div>");

            VideoFeed videoFeed = service.query(query, VideoFeed.class);
            if (videoFeed != null) {

                for (VideoEntry ve : videoFeed.getEntries()) {
                    YouTubeMediaGroup mediaGroup = ve.getMediaGroup();

                    if (mediaGroup != null) {
                        String titre = ve.getTitle().getPlainText();
                        List<MediaThumbnail> thumbs = mediaGroup.getThumbnails();
                        ve.getEtag();
                        out.write("<div class=\"video\"><br/>");
                        out.write("<table border=0>");
                        out.write("<tr>");
                        out.write("<td>");
                        String vId = mediaGroup.getVideoId();
                        out.write("<button id=\"buttonTwo\" dojoType=\"dijit.form.Button\" onclick=\"showDialog(\'"+vId+"\');\" ><img src=\"" + thumbs.get(0).getUrl() + "\" border=\"0\" /></button>");
                        out.write("</td>");
                        out.write("<td>");
                        /*out.write("<object width=\"425\" height=\"344\">" +
                                "<param name=\"movie\" value=\"http://www.youtube.com/v/" + mediaGroup.getVideoId() + "?fs=1\"</param>" +
                                "<param name=\"allowFullScreen\" value=\"true\"></param>" +
                                "<embed src=\"http://www.youtube.com/v/" + mediaGroup.getVideoId() + "?fs=1\"" +
                                "type=\"application/x-shockwave-flash\"" +
                                "allowfullscreen=\"true\"" +
                                "width=\"425\" height=\"344\">" +
                                "</embed>" +
                                "</object>");

                        out.write("<br>");*/

                        /*out.write("<a href=\"" + ve.getHtmlLink().getHref() + "\" title=" + titre + "><img src=\"" + thumbs.get(0).getUrl() + "\"></a>");*/
                        //out.write("<img src=\"" + thumbs.get(0).getUrl() + "\">");
                        out.write(printVideoEntry(ve, true));
                        out.write("</td>");
                        out.write("</tr>");
                        out.write("</table>");
                        out.write("</div>");
                    }
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    public static String printVideoEntry(
            VideoEntry videoEntry, boolean detailed) {
        String msg = "";
        msg +=
                ("Title: " + videoEntry.getTitle().getPlainText() + "<br>");

        if (videoEntry.isDraft()) {
            msg += ("Video is not live" + "<br>");
            YtPublicationState pubState = videoEntry.getPublicationState();
            if (pubState.getState() == YtPublicationState.State.PROCESSING) {
                msg += ("Video is still being processed." + "<br>");
            } else if (pubState.getState() == YtPublicationState.State.REJECTED) {
                msg += ("Video has been rejected because: ");
                msg +=
                        (pubState.getDescription() + "<br>");
                msg +=
                        ("For help visit: ");
                msg +=
                        (pubState.getHelpUrl() + "<br>");
            } else if (pubState.getState() == YtPublicationState.State.FAILED) {
                msg += ("Video failed uploading because: ");
                msg +=
                        (pubState.getDescription() + "<br>");
                msg +=
                        ("For help visit: ");
                msg +=
                        (pubState.getHelpUrl() + "<br>");
            }

        }

        if (videoEntry.getEditLink() != null) {
            msg += ("Video is editable by current user." + "<br>");
        }

        if (detailed) {

            YouTubeMediaGroup mediaGroup = videoEntry.getMediaGroup();

            msg +=
                    ("Uploaded by: " + mediaGroup.getUploader() + "<br>");

            msg +=
                    ("Video ID: " + mediaGroup.getVideoId() + "<br>");
            msg +=
                    ("Description: " +
                    mediaGroup.getDescription().getPlainTextContent() + "<br>");

            MediaPlayer mediaPlayer = mediaGroup.getPlayer();
            msg +=
                    ("Web Player URL: " + mediaPlayer.getUrl() + "<br>");
            MediaKeywords keywords = mediaGroup.getKeywords();
            msg +=
                    ("Keywords: ");
            for (String keyword : keywords.getKeywords()) {
                msg += (keyword + ",");
            }

            GeoRssWhere location = videoEntry.getGeoCoordinates();
            if (location != null) {
                msg += ("Latitude: " + location.getLatitude() + "<br>");
                msg +=
                        ("Longitude: " + location.getLongitude() + "<br>");
            }

            Rating rating = videoEntry.getRating();
            if (rating != null) {
                msg += ("Average rating: " + rating.getAverage() + "<br>");
            }

            YtStatistics stats = videoEntry.getStatistics();
            if (stats != null) {
                msg += ("View count: " + stats.getViewCount() + "<br>");
            }
//msg +=();

            /*msg +=("\tThumbnails:");
            for (MediaThumbnail mediaThumbnail : mediaGroup.getThumbnails()) {
            msg +=("\t\tThumbnail URL: " + mediaThumbnail.getUrl());
            msg +=("\t\tThumbnail Time Index: " +
            mediaThumbnail.getTime());
            //msg +=();
            }

            msg +=("\tMedia:");
            for (YouTubeMediaContent mediaContent : mediaGroup.getYouTubeContents()) {
            msg +=("\t\tMedia Location: " + mediaContent.getUrl());
            msg +=("\t\tMedia Type: " + mediaContent.getType());
            msg +=("\t\tDuration: " + mediaContent.getDuration());
            //msg +=();
            }*/
            for (YouTubeMediaRating mediaRating : mediaGroup.getYouTubeRatings()) {
                msg += ("Video restricted in the following countries: " +
                        mediaRating.getCountries().toString() + "<br>");
            }

        }
        return msg;
    }
}
